VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CHotKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal ID As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Private Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal ID As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'--------------------------------------------------------------
Public Enum EnumHotkeyModifier
    MOD_ALT = &H1&
    MOD_CONTROL = &H2&
    MOD_SHIFT = &H4&
    MOD_WIN = &H8&
End Enum
'--------------------------------------------------------------
Private Const WM_KEYDOWN = &H100
Private Const WM_HOTKEY = &H312
'**************************************************************

Public PreWndProcAddress As Long

Private m_hWnd As Long
Private mHotKeyIDs As Collection
Private mflgStop As Boolean

Public Event HotKey(ByVal HotKey As KeyCodeConstants, ByVal Mask As EnumHotkeyModifier)
Public Event HotKeyEx(ByVal HotKey As KeyCodeConstants, ByVal Mask As EnumHotkeyModifier, ByRef Through As Boolean)

' === zbgL[̃Zbg ===
Public Function SetHotKey(ByVal hwnd As Long, _
                          ByVal HotKey As KeyCodeConstants, _
                          Optional ByVal Mask As EnumHotkeyModifier = 0&) As Boolean
    Dim HotKeyID As Long

    m_hWnd = hwnd
    
    HotKeyID = GetHotKeyID(HotKey, Mask)
    SetHotKey = SetHotKeyID(HotKeyID)
    
    'zbgL[LȂ烊X^[g
    If SetHotKey And Not mflgStop Then
        Call StartHotKeys
    End If
End Function

' === zbgL[̉ ===
Public Sub ResetHotKey(ByVal HotKey As KeyCodeConstants, ByVal Mask As EnumHotkeyModifier)
    Call ResetHotKeyID(GetHotKeyID(HotKey, Mask))
End Sub

' === zbgL[ׂĉ ===
Public Sub ResetHotKeys()
    Dim ID As Variant
    
    For Each ID In mHotKeyIDs
        Call ResetHotKeyID(ID)
    Next ID
    
    Call EndSubClass_(Me)
    mflgStop = True
End Sub

' === zbgL[X^[g ===
Public Sub StartHotKeys()
    Dim ID As Variant
    
    'zbgL[̃Zbg
    For Each ID In mHotKeyIDs
        Call SetHotKeyID(ID, False)
    Next ID
    
    Call EndSubClass_(Me)
    Call StartSubClass_(Me)
    mflgStop = False
End Sub

' === zbgL[ꎞ ===
Public Sub StopHotKeys()
    Dim ID As Variant
    
    'zbgL[̃Zbg
    For Each ID In mHotKeyIDs
        Call ResetHotKeyID(ID, False)
    Next ID
    
    Call EndSubClass_(Me)
    mflgStop = True
End Sub


Public Property Get hwnd() As Long
    hwnd = m_hWnd
End Property

Public Function WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim Through As Boolean
    
    WindowProc = API_TRUE
    Select Case iMsg
     Case WM_HOTKEY
        'o^ĂHotKeyȂCxg𔭐
        If IsExist(mHotKeyIDs, CStr(lParam)) Then
            RaiseEvent HotKey(GetHotKey(lParam), GetMask(lParam))
            RaiseEvent HotKeyEx(GetHotKey(lParam), GetMask(lParam), Through)
            If Through Then
                WindowProc = API_TRUE
            Else
                WindowProc = API_FALSE
            End If
        End If
    End Select
End Function

Private Sub Class_Initialize()
    'zbgL[Xg̐
    Set mHotKeyIDs = New Collection
    
    'ŏ̓zbgL[LƂ݂Ȃ
    mflgStop = False
End Sub

Private Sub Class_Terminate()
    'zbgL[̉
    Call ResetHotKeys
    
    'zbgL[Xg̊J
    Set mHotKeyIDs = Nothing
End Sub

Private Function SetHotKeyID(ByVal HotKeyID As Long, Optional AddList As Boolean = True) As Boolean
    Dim rtn As Long
    
    'IDXgɑ݂鎞͏Ȃ
    If IsExist(mHotKeyIDs, CStr(HotKeyID)) Then Exit Function
    
    'zbgL[Zbg
    rtn = RegisterHotKey(m_hWnd, HotKeyID, GetMask(HotKeyID), GetHotKey(HotKeyID))
    
    'Xgɒǉ
    If AddList And (rtn <> API_FALSE) Then
        Call mHotKeyIDs.Add(HotKeyID, CStr(HotKeyID))
    End If
    
    SetHotKeyID = (rtn <> API_FALSE)
End Function

Private Sub ResetHotKeyID(ByVal HotKeyID As Long, Optional DeleteList As Boolean = True)
    'IDXgɑ݂ȂΏȂ
    If Not IsExist(mHotKeyIDs, CStr(HotKeyID)) Then Exit Sub
    
    'zbgL[
    Call UnregisterHotKey(m_hWnd, HotKeyID)
    
    'Xg폜
    If DeleteList Then
        Call mHotKeyIDs.Remove(CStr(HotKeyID))
    End If
End Sub

'IDHotKey,Mask̑ݕϊ
Private Function GetHotKeyID(ByVal HotKey As KeyCodeConstants, ByVal Mask As EnumHotkeyModifier) As Long
    GetHotKeyID = HotKey * &H10000 + Mask
End Function
Private Function GetHotKey(ByVal HotKeyID As Long) As KeyCodeConstants
    GetHotKey = HotKeyID \ &H10000
End Function
Private Function GetMask(ByVal HotKeyID As Long) As EnumHotkeyModifier
    GetMask = HotKeyID And &HFFFF&
End Function

'RNV̑݃`FbN
Private Function IsExist(ByRef col As Collection, ByVal Index As Variant) As Boolean
    Dim buf As Variant
    
    On Error Resume Next
    
    buf = col(Index)
    
    If Err.Number = 0 Then
        IsExist = True
    Else
        IsExist = False
    End If
End Function
