Attribute VB_Name = "mdlMemo"
Option Explicit

Public Type typeTimer
    Time As Date
    Command As String
End Type

Public Type typeGlobalOption
    TopMost             As Boolean
    StartUpTray         As Boolean
    UnresidentInfo      As Boolean
    IMEState            As Boolean
    HideAfterRun        As Boolean
    NoTray              As Boolean

    MemoFileName        As String

    HotKey              As Long
    HotKeyMask          As Long

    MRU                 As Integer
    
    SetClipboard        As Boolean
    IfVoidThenHide      As Boolean
    ShowErrMsg          As Boolean
    
    ScriptLanguage      As String
    ScriptFile          As String
    
    Timer()             As typeTimer
End Type

Public ini As CIniFile
Public pGlobalOption As typeGlobalOption

Public pPropertyTabPosition As Integer
Public pPropertyTimerMode   As Integer

Public Const cRunError      As Long = 0
Public Const cRunVBS        As Long = 1
Public Const cRunOpen       As Long = 2
Public Const cRunAddMemo    As Long = 3

Public Const cFindModeIni As Long = 0
Public Const cFindModeList As Long = 1

Public Sub LoadIniFile(ByRef F As Form)
    Dim i As Integer
    Dim Key As Variant

    'IvVlݒ
    With pGlobalOption
        .TopMost = False
        .StartUpTray = False
        .UnresidentInfo = True
        .IMEState = True
        .HideAfterRun = True
        .NoTray = False
        
        .MemoFileName = AppPath() & App.EXEName & ".txt"
        
        .HotKeyMask = 8& '[Windows]L[
        .HotKey = vbKeyZ
        
        .MRU = 10
        
        .SetClipboard = False
        .IfVoidThenHide = False
        .ShowErrMsg = True
        
        .ScriptLanguage = "VBScript"
        .ScriptFile = AppPath & App.EXEName & ".vbs"
        
        ReDim .Timer(0) As typeTimer
    End With

    'tH[TCYʒȕ
    Dim DefHeight As Long
    Dim DefWidth  As Long
    DefHeight = (F.Height - F.ScaleHeight) + F.cmbMemo.Height + F.ctlMemo.Height
    DefWidth = 58951
    With Screen
        Call F.Move((.Width - DefWidth) / 2, (.Height - DefHeight) / 2, DefWidth, DefHeight)
    End With
    
    'init@C̏
    Set ini = New CIniFile
    Call ini.Load(AppPath & App.EXEName & ".ini")
    
    'IvṼZbg
    With pGlobalOption
        ini.NowSection = "Options"
        
        'IvV`FbN
        If Not IsBool(ini.Data("TopMost")) Then ini.Data("TopMost") = .TopMost
        If Not IsBool(ini.Data("StartUpTray")) Then ini.Data("StartUpTray") = .StartUpTray
        If Not IsBool(ini.Data("UnresidentInfo")) Then ini.Data("UnresidentInfo") = .UnresidentInfo
        If Not IsBool(ini.Data("IMEState")) Then ini.Data("IMEState") = .IMEState
        If Not IsBool(ini.Data("HideAfterRun")) Then ini.Data("HideAfterRun") = .HideAfterRun
        If Not IsBool(ini.Data("NoTray")) Then ini.Data("NoTray") = .NoTray
        
        If ini.Data("MemoFileName") = "" Then ini.Data("MemoFileName") = .MemoFileName
        
        Select Case ini.Data("HotKeyMask")
         Case ""
            ini.Data("HotKeyMask") = .HotKeyMask
         Case "3", "7", "8"
            '
         Case Else
            ini.Data("HotKeyMask") = 0
            ini.Data("HotKey") = 0
        End Select
        If ini.Data("HotKey") = "" Then
            ini.Data("HotKey") = .HotKey
        ElseIf IsInt(ini.Data("HotKey")) Then
            Select Case CInt(ini.Data("HotKey"))
             Case 48 To 57, 65 To 90, 96 To 105
                '
             Case Else
                ini.Data("HotKeyMask") = 0
                ini.Data("HotKey") = 0
            End Select
        Else
            ini.Data("HotKeyMask") = 0
            ini.Data("HotKey") = 0
        End If
        If ini.Data("HotKeyMask") = "" Then ini.Data("HotKeyMask") = .HotKeyMask
        If ini.Data("HotKey") = "" Then ini.Data("HotKey") = .HotKey
        
        If IsInt(ini.Data("MRU")) Then
            Select Case CInt(ini.Data("MRU"))
             Case -1, 0 To 50
             Case Else
                ini.Data("MRU") = .MRU
            End Select
        Else
            ini.Data("MRU") = .MRU
        End If
        
        If Not IsBool(ini.Data("SetClipboard")) Then ini.Data("SetClipboard") = .SetClipboard
        If Not IsBool(ini.Data("IfVoidThenHide")) Then ini.Data("IfVoidThenHide") = .IfVoidThenHide
        If Not IsBool(ini.Data("ShowErrMsg")) Then ini.Data("ShowErrMsg") = .ShowErrMsg
        
        'IvVZbg
        .TopMost = CBool(ini.Data("TopMost"))
        .StartUpTray = CBool(ini.Data("StartUpTray"))
        .UnresidentInfo = CBool(ini.Data("UnresidentInfo"))
        .IMEState = CBool(ini.Data("IMEState"))
        .HideAfterRun = CBool(ini.Data("HideAfterRun"))
        .NoTray = CBool(ini.Data("NoTray"))
        
        .MemoFileName = ini.Data("MemoFileName")
        
        .HotKeyMask = CLng(ini.Data("HotKeyMask"))
        .HotKey = CLng(ini.Data("HotKey"))
        
        .MRU = CLng(ini.Data("MRU"))
        
        .SetClipboard = CBool(ini.Data("SetClipboard"))
        .IfVoidThenHide = CBool(ini.Data("IfVoidThenHide"))
        .ShowErrMsg = CBool(ini.Data("ShowErrMsg"))
    End With
    
    'ȃIvV
    With ini
        For Each Key In .Keys
            Select Case Key
             Case "TopMost"
             Case "StartUpTray"
             Case "UnresidentInfo"
             Case "IMEState"
             Case "HideAfterRun"
             Case "NoTray"
             Case "MemoFileName"
             Case "HotKeyMask", "HotKey"
             Case "MRU"
             Case "SetClipboard", "IfVoidThenHide", "ShowErrMsg"
             Case Else
                Call .DeleteData(Key)
            End Select
        Next Key
    End With
    
    'IvVxinit@CɕۑĂ܂
    Call ini.Save("Options")
    
    'tH[ʒũZbg
    With ini
        .NowSection = "Position"
        F.Width = .InitData("Width", eIniType_Long, 3000)
        .Data("Width") = F.Width
        F.ctlMemo.Height = .InitData("Height", eIniType_Long, 1500)
        .Data("Height") = F.ctlMemo.Height
        F.Left = .InitData("Left", eIniType_Long, (Screen.Width - F.Width) / 2)
        .Data("Left") = F.Left
        F.Top = .InitData("Top", eIniType_Long, (Screen.Height - F.Height) / 2)
        .Data("Top") = F.Top
        
        'ȃIvV
        For Each Key In .Keys
            Select Case Key
             Case "Left", "Top", "Width", "Height"
             Case Else
                Call .DeleteData(Key)
            End Select
        Next Key
        
        'ʒuxinit@CɕۑĂ܂
        Call ini.Save("Position")
    End With
    
    'R}h̃Zbg
    With ini
        .NowSection = "Command"
        For Each Key In .Keys
            If InStr(.Data(Key), ",") <= 0 Then
                Call .DeleteData(Key)
            End If
        Next Key
    End With
    
    'R}hC̏
    Dim strCmdList() As String
    strCmdList = Split(Command, " ")
    For i = LBound(strCmdList) To UBound(strCmdList)
        Select Case strCmdList(i)
         Case "/nohotkey"
            pGlobalOption.HotKey = 0
            pGlobalOption.HotKeyMask = 0
         Case "/tray"
            pGlobalOption.StartUpTray = True
         Case "/topmost"
            pGlobalOption.TopMost = True
        End Select
    Next i
    Erase strCmdList
End Sub

'^C}[̓o^폜
Public Function RegistTimer(ByRef tm As typeTimer) As Integer
    ReDim Preserve pGlobalOption.Timer(UBound(pGlobalOption.Timer) + 1) As typeTimer
    With pGlobalOption.Timer(UBound(pGlobalOption.Timer))
        .Time = tm.Time
        .Command = tm.Command
    End With
    RegistTimer = UBound(pGlobalOption.Timer)
End Function
Public Function UnRegistTimer(ByVal TimerID As Integer) As Boolean
    Dim i As Integer
    For i = TimerID To UBound(pGlobalOption.Timer) - 1
        pGlobalOption.Timer(i) = pGlobalOption.Timer(i + 1)
    Next i
    ReDim Preserve pGlobalOption.Timer(UBound(pGlobalOption.Timer) - 1) As typeTimer
End Function


Public Sub OLEDragDrop(Object As Object, Data As DataObject)
    Dim strAddData As String
    
    If Data.GetFormat(vbCFText) Then
        strAddData = Data.GetData(vbCFText)
    ElseIf Data.GetFormat(vbCFFiles) Then
        strAddData = Data.Files(1)
    Else
        'Ȃ
    End If
    
    'Xy[X܂ł΁A_uNH[gň͂
    If InStr(strAddData, " ") > 0 Then
        strAddData = """" & strAddData & """"
    End If
    
    'ɉ͂Ă΁AԂɃXy[Xt
    If Len(Object.Text) > 0 And Right$(Object.Text, 1) <> " " Then
        Object.Text = Object.Text & " "
    End If
    
    Object.Text = Object.Text & strAddData
End Sub

'*** R}hɕAꂼEWJ ***
Public Function SplitCommand(ByVal strCommand As String, Optional Mode As Long = cFindModeIni, Optional List As ListItems = Nothing) As String()
    Dim WorkList() As String
    Dim SubList() As String
    Dim CommandList() As String
    Dim pos As Integer
    Dim i As Integer, j As Integer

    'G[
    If Trim$(strCommand) = "" Then
        SplitCommand = Split("")
        Exit Function
    End If
    
    'R}h𕪊
    WorkList = Split("")
    strCommand = Trim$(strCommand)
    pos = InStr(strCommand, "|")
    Do While pos > 0
        If pos = 1 Then
            strCommand = Mid$(strCommand, 2)
            pos = InStr(strCommand, "|")
        ElseIf Mid$(strCommand, pos - 1, 1) = "%" Then
            pos = InStr(pos + 1, strCommand, "|")
        Else
            ReDim Preserve WorkList(UBound(WorkList) + 1) As String
            WorkList(UBound(WorkList)) = Trim$(Left$(strCommand, pos - 1))
            strCommand = Trim$(Mid$(strCommand, pos + 1))
            pos = InStr(strCommand, "|")
        End If
    Loop
    ReDim Preserve WorkList(UBound(WorkList) + 1) As String
    WorkList(UBound(WorkList)) = Trim$(strCommand)
    
    
    'R}hWJ
    CommandList = Split("")
    For i = LBound(WorkList) To UBound(WorkList)
        WorkList(i) = CommandFind(WorkList(i), Mode, List)
        If WorkList(i) = "" Then
            SubList = Split("")
        ElseIf Len(Replace(WorkList(i), "|", "")) = Len(Replace(WorkList(i), "%|", "%")) Then
            ReDim SubList(0) As String
            SubList(0) = WorkList(i)
        Else
            SubList = SplitCommand(WorkList(i), Mode, List)
        End If
        
        For j = LBound(SubList) To UBound(SubList)
            ReDim Preserve CommandList(UBound(CommandList) + 1) As String
            CommandList(UBound(CommandList)) = Replace$(SubList(j), "%|", "|")
        Next j
    Next i
    
    'ʂԂĕϐJ
    SplitCommand = CommandList
    Erase WorkList
    Erase SubList
    Erase CommandList
End Function

'*** R}hEWJ ***
Private Function CommandFind(ByVal strCommand As String, Optional Mode As Long = cFindModeIni, Optional List As ListItems = Nothing) As String
    Dim ArgList() As String
    Dim Cmd As String
    Dim Result As String
    Dim i As Integer, j As Integer

    'ȂɂĂȂΏ𔲂
    If Trim$(strCommand) = "" Then
        CommandFind = ""
        Exit Function
    End If

    '1)R}hƁAɕ
    ArgList = Split(strCommand, " ")
    Cmd = ArgList(0)
    j = 0
    For i = 1 To UBound(ArgList)
        If ArgList(i) <> "" Then
            ArgList(j) = ArgList(i)
            j = j + 1
        End If
    Next i
    If j = 0 Then
        ArgList = Split("")
    Else
        ReDim Preserve ArgList(j - 1) As String
    End If
    
    '2)R}h
    Select Case Mode
     Case cFindModeIni
        'init@C̎QƃZNVύX
        If ini.NowSection <> "Command" Then ini.NowSection = "Command"
        
        'R}ȟ
        Result = ini.Data(Cmd)
        If Result <> "" Then
            Result = Split(Result, ",", 2)(1)
        End If
     
     Case cFindModeList
        On Error Resume Next
        Result = List(Cmd).SubItems(2)
        If Err.Number = 35601 Then
            Result = ""
        End If
        On Error GoTo 0
        
    End Select
    
    '3)ΈWJĕԂAȂstrCommand̂܂ܕԂ
    If Result <> "" Then
        CommandFind = ReplaceArg(Result, ArgList, Mode, List)
    Else
        CommandFind = strCommand
    End If
    
    '4)ϐJ
    Erase ArgList
End Function

'*** ̉ ***
Private Function ReplaceArg(ByVal Expression As String, _
                           ByRef ArgList() As String, _
                           Optional Mode As Long = cFindModeIni, _
                           Optional List As ListItems = Nothing) As String
    Dim pos As Long, PrePos As Long
    Dim c As String
    Dim Index As Integer
    Dim i As Integer
    Dim buf As String
    
    PrePos = 1
    pos = InStr(PrePos, Expression, "%")
    Do While pos > 0
        ReplaceArg = ReplaceArg & Mid$(Expression, PrePos, pos - PrePos)
        c = Mid$(Expression, pos + 1, 1)
        Select Case c
         Case "%"
            ReplaceArg = ReplaceArg & "%"
         Case "a"
            ReplaceArg = ReplaceArg & Join$(ArgList, " ")
         Case "A"
            ReplaceArg = ReplaceArg & URLEncode(Join$(ArgList, " "))
         Case "b" To "z"
            Index = Asc(c) - Asc("b")
            If Index >= LBound(ArgList) And Index <= UBound(ArgList) Then
                ReplaceArg = ReplaceArg & ArgList(Index)
            End If
         Case "B" To "Z"
            Index = Asc(c) - Asc("B")
            If Index >= LBound(ArgList) And Index <= UBound(ArgList) Then
                ReplaceArg = ReplaceArg & URLEncode(ArgList(Index))
            End If
         Case Else
            ReplaceArg = ReplaceArg & "%" & c
        End Select
        PrePos = pos + 2
        pos = InStr(PrePos, Expression, "%")
    Loop
    ReplaceArg = ReplaceArg & Mid$(Expression, PrePos)

    i = InStr(ReplaceArg, "%`")
    Do While i > 0
        buf = CommandFind(Mid$(ReplaceArg, i + 2, InStr(i + 2, ReplaceArg & "`", "`") - i - 2), Mode, List)
        If buf = "" Then buf = Mid$(ReplaceArg, i + 2, InStr(i + 2, ReplaceArg & "`", "`") - i - 2)
        ReplaceArg = Left$(ReplaceArg, i - 1) & _
                        buf & _
                        Mid$(ReplaceArg, InStr(i + 2, ReplaceArg & "`", "`") + 1)
        i = InStr(i, ReplaceArg, "%`")
    Loop
    
    i = InStr(ReplaceArg, "%{")
    Do While i > 0
        buf = Mid$(ReplaceArg, i + 2, InStr(i, ReplaceArg & "}", "}") - i - 2)
        If pMemo.pEval.RunCode(buf) Then
            buf = pMemo.pEval.Result
        End If
        ReplaceArg = Left$(ReplaceArg, i - 1) & _
                        buf & _
                        Mid$(ReplaceArg, InStr(i, ReplaceArg & "}", "}") + 1)
        i = InStr(i, ReplaceArg, "%{")
    Loop
    
    ReplaceArg = Replace$(ReplaceArg, "%%", "%")

End Function


Private Function URLEncode(ByVal strEncode As String) As String
'----------------------------------------------------
'      : ֐
' @\Tv : URLGR[h
'      : strEncode GR[h
' ߂l   : GR[hl
' 쐬   : 1999/03/31
' XV : 2000/04/11
'----------------------------------------------------
    Dim i As Integer
    Dim buf() As Byte
    
    buf = StrConv(strEncode, vbFromUnicode)
    For i = 0 To UBound(buf)
        Select Case buf(i)
         Case 48 To 57, 65 To 90, 97 To 122 ' 0 ` 9, A ` Z, a ` z
            URLEncode = URLEncode & Chr$(buf(i))
         Case Else
            URLEncode = URLEncode & "%" & Right$("00" & Hex(buf(i)), 2)
        End Select
    Next i
End Function
