VERSION 5.00
Begin VB.UserControl uSpinButton 
   ClientHeight    =   330
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1035
   ScaleHeight     =   330
   ScaleWidth      =   1035
   Begin VB.VScrollBar Spin 
      Height          =   315
      Left            =   840
      Max             =   2
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Value           =   1
      Width           =   195
   End
   Begin VB.TextBox Text 
      Alignment       =   1  'E
      Height          =   330
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "uSpinButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'****************************************************************************************************
'      : [U[Rg[()
' @\Tv : Xs{^Rg[
' 쐬   : 2000/05/
' XV : 2001/02/10 wb_Rgt
'          : 2001/04/24 LockedvpeBǉ
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'----------------------------------------------------------------------------------------------------
' l     :
'****************************************************************************************************

Private m_Value As Long
Private m_Max As Long
Private m_Min As Long

Private m_flgTextChange As Boolean

Public Event Change()
Public Event KeyPress(ByRef KeyAscii As Integer)

Public Property Get Value() As Long
    Value = m_Value
End Property
Public Property Let Value(ByVal NewValue As Long)
    If NewValue < m_Min Or NewValue > m_Max Then Exit Property
    
    m_Value = NewValue
    Text.Text = m_Value
    Call UserControl.PropertyChanged("Value")
End Property

Public Property Get Max() As Long
    Max = m_Max
End Property
Public Property Let Max(ByVal NewMax As Long)
    m_Max = NewMax
    Call UserControl.PropertyChanged("Max")
End Property

Public Property Get Min() As Long
    Min = m_Min
End Property
Public Property Let Min(ByVal NewMin As Long)
    m_Min = NewMin
    Call UserControl.PropertyChanged("Min")
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewEnabled As Boolean)
    UserControl.Enabled = NewEnabled
    Text.Enabled = NewEnabled
    Spin.Enabled = NewEnabled
    Call UserControl.PropertyChanged("Enabled")
End Property

Public Property Get Locked() As Boolean
    Locked = Text.Locked
End Property
Public Property Let Locked(ByVal NewLocked As Boolean)
    Text.Locked = NewLocked
    Spin.Enabled = Not NewLocked
    Call UserControl.PropertyChanged("Locked")
End Property

Private Sub Spin_Change()
    Select Case Spin.Value
     Case 0
        Me.Value = Me.Value + 1
        Spin.Value = 1
     Case 1
        'Ȃ
     Case 2
        Me.Value = Me.Value - 1
        Spin.Value = 1
    End Select
    
    If Not m_flgTextChange Then
        With Text
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
    End If
    RaiseEvent Change
End Sub

Private Sub Spin_GotFocus()
    Call Text.SetFocus
End Sub

Private Sub Text_Change()
    Dim wrkSelStart As Integer
    If m_flgTextChange Then Exit Sub
    m_flgTextChange = True
    If Text.Text = "" Then
        With Text
            .Text = m_Min
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
    ElseIf Text.Text Like "*[!0-9-]*" Or Text.Text = "-" Then
        wrkSelStart = Text.SelStart
        Text.Text = Me.Value
        Text.SelStart = wrkSelStart
    Else
        If CLng(Text.Text) < m_Min Or CLng(Text.Text) > m_Max Then
            wrkSelStart = Text.SelStart
            Text.Text = Me.Value
            Text.SelStart = wrkSelStart
        Else
            Me.Value = Text.Text
        End If
    End If
    m_flgTextChange = False
End Sub

Private Sub Text_GotFocus()
    With Text
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

Private Sub Text_KeyPress(KeyAscii As Integer)
    If Locked Then Exit Sub

    RaiseEvent KeyPress(KeyAscii)
    Select Case KeyAscii
     Case Asc("0") To Asc("9"), Asc("-"), vbKeyBack
     Case Else
        KeyAscii = 0
    End Select
End Sub

Private Sub Text_KeyDown(KeyCode As Integer, Shift As Integer)
    If Locked Then Exit Sub
    
    If Shift <> 0 Then Exit Sub
    Select Case KeyCode
     Case vbKeyUp
        Me.Value = Me.Value + 1
        With Text
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
        KeyCode = 0
     Case vbKeyDown
        Me.Value = Me.Value - 1
        With Text
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
        KeyCode = 0
    End Select
End Sub

Private Sub Text_KeyUp(KeyCode As Integer, Shift As Integer)
    If Locked Then Exit Sub
    
    If Shift <> 0 Then Exit Sub
    Select Case KeyCode
     Case vbKeyUp, vbKeyDown
        With Text
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
        KeyCode = 0
    End Select
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    With UserControl
        Call Text.Move(0, 0, .ScaleWidth - Spin.Width)
        Call Spin.Move(Text.Width, 0, Spin.Width)
        .Height = Text.Height
    End With
End Sub

Private Sub UserControl_InitProperties()
    Me.Min = 0
    Me.Max = 50
    Me.Value = 0
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        Me.Min = .ReadProperty("Min", 0)
        Me.Max = .ReadProperty("Max", 50)
        Me.Value = .ReadProperty("Value", 0)
        Me.Enabled = .ReadProperty("Enabled", True)
        Me.Locked = .ReadProperty("Locked", False)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        Call .WriteProperty("Min", Me.Min, 0)
        Call .WriteProperty("Max", Me.Max, 50)
        Call .WriteProperty("Value", Me.Value, 0)
        Call .WriteProperty("Enabled", Me.Enabled, True)
        Call .WriteProperty("Locked", Me.Locked, False)
    End With
End Sub
